Index: /code/trunk/src/modules/objects/eventsystem/EventListener.cc
===================================================================
--- /code/trunk/src/modules/objects/eventsystem/EventListener.cc	(revision 5928)
+++ /code/trunk/src/modules/objects/eventsystem/EventListener.cc	(revision 5929)
@@ -63,7 +63,5 @@
 
         this->bActive_ = true;
-
-        this->fireEvent(event.activate_, event.originator_);
-
+        this->fireEvent(event.activate_, event.originator_, event.name_);
         this->bActive_ = false;
     }
@@ -78,5 +76,5 @@
         for (ObjectList<BaseObject>::iterator it = ObjectList<BaseObject>::begin(); it != ObjectList<BaseObject>::end(); ++it)
             if (it->getName() == this->eventName_)
-                this->registerAsListener(*it);
+                this->addEventSource(*it, "");
     }
 
@@ -87,10 +85,5 @@
 
         if (object->getName() == this->eventName_)
-            this->registerAsListener(object);
-    }
-
-    void EventListener::registerAsListener(BaseObject* object)
-    {
-        object->registerEventListener(this, "");
+            this->addEventSource(object, "");
     }
 }
Index: /code/trunk/src/modules/objects/eventsystem/EventListener.h
===================================================================
--- /code/trunk/src/modules/objects/eventsystem/EventListener.h	(revision 5928)
+++ /code/trunk/src/modules/objects/eventsystem/EventListener.h	(revision 5929)
@@ -54,5 +54,4 @@
         private:
             virtual void loadedNewXMLName(BaseObject* object);
-            void registerAsListener(BaseObject* object);
 
             std::string eventName_;
Index: /code/trunk/src/modules/objects/eventsystem/EventName.cc
===================================================================
--- /code/trunk/src/modules/objects/eventsystem/EventName.cc	(revision 5929)
+++ /code/trunk/src/modules/objects/eventsystem/EventName.cc	(revision 5929)
@@ -0,0 +1,40 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "EventName.h"
+#include "core/CoreIncludes.h"
+
+namespace orxonox
+{
+    CreateFactory(EventName);
+
+    EventName::EventName(BaseObject* creator) : BaseObject(creator)
+    {
+        RegisterObject(EventName);
+    }
+}
Index: /code/trunk/src/modules/objects/eventsystem/EventName.h
===================================================================
--- /code/trunk/src/modules/objects/eventsystem/EventName.h	(revision 5929)
+++ /code/trunk/src/modules/objects/eventsystem/EventName.h	(revision 5929)
@@ -0,0 +1,46 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _EventName_H__
+#define _EventName_H__
+
+#include "objects/ObjectsPrereqs.h"
+
+#include "core/BaseObject.h"
+
+namespace orxonox
+{
+    class _ObjectsExport EventName : public BaseObject
+    {
+        public:
+            EventName(BaseObject* creator);
+            virtual ~EventName() {}
+    };
+}
+
+#endif /* _EventName_H__ */
Index: /code/trunk/src/modules/objects/eventsystem/EventTarget.cc
===================================================================
--- /code/trunk/src/modules/objects/eventsystem/EventTarget.cc	(revision 5928)
+++ /code/trunk/src/modules/objects/eventsystem/EventTarget.cc	(revision 5929)
@@ -29,4 +29,5 @@
 #include "EventTarget.h"
 #include "core/CoreIncludes.h"
+#include "core/XMLPort.h"
 
 namespace orxonox
@@ -37,4 +38,6 @@
     {
         RegisterObject(EventTarget);
+
+        this->bActive_ = false;
     }
 
@@ -42,27 +45,50 @@
     {
     }
+    
+    void EventTarget::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(EventTarget, XMLPort, xmlelement, mode);
 
-    void EventTarget::changedName()
+        XMLPortParam(EventTarget, "target", setTargetName, getTargetName, xmlelement, mode);
+
+        // since we need event sources mapped to any state, we have to parse XML by ourselves
+        this->loadAllEventStates(xmlelement, mode, this, Class(EventTarget));
+    }
+
+    void EventTarget::processEvent(Event& event)
     {
-        SUPER(EventTarget, changedName);
+        if (this->bActive_)
+        {
+            COUT(2) << "Warning: Detected Event loop in EventTarget \"" << this->getName() << "\"" << std::endl;
+            return;
+        }
 
+        this->bActive_ = true;
+        this->fireEvent(event);
+        this->bActive_ = false;
+    }
+
+    void EventTarget::setTargetName(const std::string& name)
+    {
+        this->target_ = name;
+        
         for (ObjectList<BaseObject>::iterator it = ObjectList<BaseObject>::begin(); it != ObjectList<BaseObject>::end(); ++it)
-            if (it->getName() == this->getName())
-                this->addAsEvent(*it);
+            if (it->getName() == this->target_)
+                this->addEventTarget(*it);
     }
 
     void EventTarget::loadedNewXMLName(BaseObject* object)
     {
-        if (this->getName() == "")
+        if (this->target_ == "")
             return;
 
-        if (object->getName() == this->getName())
-            this->addAsEvent(object);
+        if (object->getName() == this->target_)
+            this->addEventTarget(object);
     }
 
-    void EventTarget::addAsEvent(BaseObject* object)
+    void EventTarget::addEventTarget(BaseObject* object)
     {
         if (object != static_cast<BaseObject*>(this))
-            object->addEvent(this, "");
+            object->addEventSource(this, "");
     }
 }
Index: /code/trunk/src/modules/objects/eventsystem/EventTarget.h
===================================================================
--- /code/trunk/src/modules/objects/eventsystem/EventTarget.h	(revision 5928)
+++ /code/trunk/src/modules/objects/eventsystem/EventTarget.h	(revision 5929)
@@ -42,10 +42,19 @@
             EventTarget(BaseObject* creator);
             virtual ~EventTarget();
+            
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            
+            virtual void processEvent(Event& event);
 
-            virtual void changedName();
+            void setTargetName(const std::string& name);
+            inline const std::string& getTargetName() const
+                { return this->target_; }
 
         private:
             virtual void loadedNewXMLName(BaseObject* object);
-            void addAsEvent(BaseObject* object);
+            void addEventTarget(BaseObject* object);
+            
+            std::string target_;
+            bool bActive_;
     };
 }
Index: /code/trunk/src/modules/objects/triggers/CheckPoint.cc
===================================================================
--- /code/trunk/src/modules/objects/triggers/CheckPoint.cc	(revision 5928)
+++ /code/trunk/src/modules/objects/triggers/CheckPoint.cc	(revision 5929)
@@ -85,5 +85,5 @@
         DistanceTrigger::triggered(bIsTriggered);
 
-        Asteroids* gametype = orxonox_cast<Asteroids*>(this->getGametype());
+        Asteroids* gametype = orxonox_cast<Asteroids*>(this->getGametype().get());
         if (gametype)
         {
Index: /code/trunk/src/modules/objects/triggers/EventTrigger.cc
===================================================================
--- /code/trunk/src/modules/objects/triggers/EventTrigger.cc	(revision 5928)
+++ /code/trunk/src/modules/objects/triggers/EventTrigger.cc	(revision 5929)
@@ -47,9 +47,9 @@
     }
 
-    void EventTrigger::processEvent(Event& event)
+    void EventTrigger::XMLEventPort(Element& xmlelement, XMLPort::Mode mode)
     {
-        SUPER(EventTrigger, processEvent, event);
+        SUPER(EventTrigger, XMLEventPort, xmlelement, mode);
 
-        ORXONOX_SET_EVENT(EventTrigger, "trigger", trigger, event);
+        XMLPortEventState(EventTrigger, BaseObject, "trigger", trigger, xmlelement, mode);
     }
 
Index: /code/trunk/src/modules/objects/triggers/EventTrigger.h
===================================================================
--- /code/trunk/src/modules/objects/triggers/EventTrigger.h	(revision 5928)
+++ /code/trunk/src/modules/objects/triggers/EventTrigger.h	(revision 5929)
@@ -41,5 +41,5 @@
             virtual ~EventTrigger();
 
-            virtual void processEvent(Event& event);
+            virtual void XMLEventPort(Element& xmlelement, XMLPort::Mode mode);
 
             inline void trigger(bool bTriggered)
Index: /code/trunk/src/modules/objects/triggers/Trigger.cc
===================================================================
--- /code/trunk/src/modules/objects/triggers/Trigger.cc	(revision 5928)
+++ /code/trunk/src/modules/objects/triggers/Trigger.cc	(revision 5929)
@@ -72,5 +72,5 @@
     }
 
-    this->setObjectMode(0x0);
+    this->setSyncMode(0x0);
   }
 
Index: /code/trunk/src/modules/overlays/FadeoutText.cc
===================================================================
--- /code/trunk/src/modules/overlays/FadeoutText.cc	(revision 5928)
+++ /code/trunk/src/modules/overlays/FadeoutText.cc	(revision 5929)
@@ -46,5 +46,5 @@
 
         this->bFadingOut_ = false;
-        this->fadeouttimer_.setTimer(3.0f, false, this, createExecutor(createFunctor(&FadeoutText::fadeout)));
+        this->fadeouttimer_.setTimer(3.0f, false, createExecutor(createFunctor(&FadeoutText::fadeout, this)));
         this->fadeouttimer_.stopTimer();
 
Index: /code/trunk/src/modules/overlays/FadeoutText.h
===================================================================
--- /code/trunk/src/modules/overlays/FadeoutText.h	(revision 5928)
+++ /code/trunk/src/modules/overlays/FadeoutText.h	(revision 5929)
@@ -68,5 +68,5 @@
 
             bool bFadingOut_;
-            Timer<FadeoutText> fadeouttimer_;
+            Timer fadeouttimer_;
 
             float initialAlpha_;
Index: /code/trunk/src/modules/overlays/OverlaysPrereqs.h
===================================================================
--- /code/trunk/src/modules/overlays/OverlaysPrereqs.h	(revision 5928)
+++ /code/trunk/src/modules/overlays/OverlaysPrereqs.h	(revision 5929)
@@ -28,6 +28,7 @@
 
 /**
-  @file
-  @brief Contains all the necessary forward declarations for all classes and structs.
+@file
+@brief
+    Shared library macros, enums, constants and forward declarations for the overlays module
 */
 
@@ -36,8 +37,10 @@
 
 #include "OrxonoxConfig.h"
+#include "OrxonoxPrereqs.h"
 
 //-----------------------------------------------------------------------
 // Shared library settings
 //-----------------------------------------------------------------------
+
 #if defined(ORXONOX_PLATFORM_WINDOWS) && !defined(ORXONOX_STATIC_BUILD)
 #  ifdef OVERLAYS_SHARED_BUILD
@@ -62,23 +65,29 @@
 namespace orxonox
 {
-    class BarColour;
+    class FadeoutText;
+    class GUIOverlay;
+    class OverlayText;
+
+    // debugging
     class DebugFPSText;
     class DebugRTRText;
-    class GUIOverlay;
+
+    // hud
+    class AnnounceMessage;
+    class BarColour;
+    class ChatOverlay;
+    class DeathMessage;
+    class GametypeStatus;
     class HUDBar;
+    class HUDHealthBar;
     class HUDNavigation;
     class HUDRadar;
     class HUDSpeedBar;
-    class HUDHealthBar;
     class HUDTimer;
-    class OrxonoxOverlay;
-    class OverlayGroup;
-    class OverlayText;
-    class FadeoutText;
-    class GametypeStatus;
-    class AnnounceMessage;
     class KillMessage;
-    class DeathMessage;
+    class TeamBaseMatchScore;
+    class UnderAttackHealthBar;
 
+    // stats
     class CreateLines;
     class Scoreboard;
Index: /code/trunk/src/modules/overlays/hud/ChatOverlay.cc
===================================================================
--- /code/trunk/src/modules/overlays/hud/ChatOverlay.cc	(revision 5928)
+++ /code/trunk/src/modules/overlays/hud/ChatOverlay.cc	(revision 5929)
@@ -58,4 +58,6 @@
     ChatOverlay::~ChatOverlay()
     {
+        for (std::set<Timer*>::iterator it = this->timers_.begin(); it != this->timers_.end(); ++it)
+            delete (*it);
     }
 
@@ -87,14 +89,19 @@
         COUT(0) << "Chat: " << text << std::endl;
 
-        new Timer<ChatOverlay>(this->displayTime_, false, this, createExecutor(createFunctor(&ChatOverlay::dropMessage)), true);
+        Timer* timer = new Timer();
+        this->timers_.insert(timer); // store the timer in a set to destroy it in the destructor
+        Executor* executor = createExecutor(createFunctor(&ChatOverlay::dropMessage, this));
+        executor->setDefaultValues(timer);
+        timer->setTimer(this->displayTime_, false, executor, true);
 
         this->updateOverlayText();
     }
 
-    void ChatOverlay::dropMessage()
+    void ChatOverlay::dropMessage(Timer* timer)
     {
         if (this->messages_.size() > 0)
             this->messages_.pop_front();
         this->updateOverlayText();
+        this->timers_.erase(timer); // the timer destroys itself, but we have to remove it from the set
     }
 
Index: /code/trunk/src/modules/overlays/hud/ChatOverlay.h
===================================================================
--- /code/trunk/src/modules/overlays/hud/ChatOverlay.h	(revision 5928)
+++ /code/trunk/src/modules/overlays/hud/ChatOverlay.h	(revision 5929)
@@ -55,7 +55,8 @@
         private:
             void updateOverlayText();
-            void dropMessage();
+            void dropMessage(Timer* timer);
 
             float displayTime_;
+            std::set<Timer*> timers_;
     };
 }
Index: /code/trunk/src/modules/overlays/hud/HUDBar.cc
===================================================================
--- /code/trunk/src/modules/overlays/hud/HUDBar.cc	(revision 5928)
+++ /code/trunk/src/modules/overlays/hud/HUDBar.cc	(revision 5929)
@@ -96,5 +96,9 @@
     {
         if (this->isInitialized())
+        {
             Ogre::OverlayManager::getSingleton().destroyOverlayElement(this->bar_);
+            for (std::vector<BarColour*>::const_iterator it = this->barColours_.begin(); it != this->barColours_.end(); )
+                (*it++)->destroy();
+        }
     }
 
Index: /code/trunk/src/modules/overlays/hud/HUDHealthBar.cc
===================================================================
--- /code/trunk/src/modules/overlays/hud/HUDHealthBar.cc	(revision 5928)
+++ /code/trunk/src/modules/overlays/hud/HUDHealthBar.cc	(revision 5929)
@@ -56,5 +56,5 @@
     {
         if (this->isInitialized())
-            delete this->textoverlay_;
+            this->textoverlay_->destroy();
     }
 
@@ -84,4 +84,9 @@
             this->setValue(this->owner_->getHealth() / this->owner_->getInitialHealth());
             this->textoverlay_->setCaption(multi_cast<std::string>(static_cast<int>(this->owner_->getHealth())));
+        }
+        else
+        {
+            this->setValue(0);
+            this->textoverlay_->setCaption("0");
         }
 
Index: /code/trunk/src/modules/overlays/hud/HUDHealthBar.h
===================================================================
--- /code/trunk/src/modules/overlays/hud/HUDHealthBar.h	(revision 5928)
+++ /code/trunk/src/modules/overlays/hud/HUDHealthBar.h	(revision 5929)
@@ -111,5 +111,5 @@
 
         private:
-            Pawn* owner_;
+            WeakPtr<Pawn> owner_;
             OverlayText* textoverlay_;
             bool bUseBarColour_;
Index: /code/trunk/src/modules/overlays/hud/HUDNavigation.cc
===================================================================
--- /code/trunk/src/modules/overlays/hud/HUDNavigation.cc	(revision 5928)
+++ /code/trunk/src/modules/overlays/hud/HUDNavigation.cc	(revision 5929)
@@ -39,4 +39,5 @@
 #include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
+#include "Scene.h"
 #include "Radar.h"
 
@@ -130,5 +131,8 @@
         SUPER(HUDNavigation, tick, dt);
 
-        if (!Radar::getInstance().getFocus())
+        // Get radar
+        Radar* radar = this->getOwner()->getScene()->getRadar();
+
+        if (!radar->getFocus())
         {
             this->overlay_->hide();
@@ -150,5 +154,5 @@
 */
         // transform to screen coordinates
-        Vector3 pos = /*transformationMatrix * */Radar::getInstance().getFocus()->getRVWorldPosition();
+        Vector3 pos = /*transformationMatrix * */radar->getFocus()->getRVWorldPosition();
 
         bool outOfView;
Index: /code/trunk/src/modules/overlays/hud/TeamBaseMatchScore.cc
===================================================================
--- /code/trunk/src/modules/overlays/hud/TeamBaseMatchScore.cc	(revision 5928)
+++ /code/trunk/src/modules/overlays/hud/TeamBaseMatchScore.cc	(revision 5929)
@@ -118,5 +118,5 @@
 
         if (this->getOwner() && this->getOwner()->getGametype())
-            this->owner_ = orxonox_cast<TeamBaseMatch*>(this->getOwner()->getGametype());
+            this->owner_ = orxonox_cast<TeamBaseMatch*>(this->getOwner()->getGametype().get());
         else
             this->owner_ = 0;
Index: /code/trunk/src/modules/overlays/hud/UnderAttackHealthBar.cc
===================================================================
--- /code/trunk/src/modules/overlays/hud/UnderAttackHealthBar.cc	(revision 5928)
+++ /code/trunk/src/modules/overlays/hud/UnderAttackHealthBar.cc	(revision 5929)
@@ -52,5 +52,5 @@
         this->text_->setPickPoint(Vector2(0.5, 0));
 
-        this->inittimer_.setTimer(0.0f, false, this, createExecutor(createFunctor(&UnderAttackHealthBar::init)));
+        this->inittimer_.setTimer(0.0f, false, createExecutor(createFunctor(&UnderAttackHealthBar::init, this)));
     }
 
@@ -58,5 +58,5 @@
     {
         if (this->isInitialized())
-            delete this->text_;
+            this->text_->destroy();
     }
 
@@ -78,5 +78,5 @@
             this->owner_ = player;
 
-            UnderAttack* ua = orxonox_cast<UnderAttack*>(player->getGametype());
+            UnderAttack* ua = orxonox_cast<UnderAttack*>(player->getGametype().get());
             if (ua)
             {
Index: /code/trunk/src/modules/overlays/hud/UnderAttackHealthBar.h
===================================================================
--- /code/trunk/src/modules/overlays/hud/UnderAttackHealthBar.h	(revision 5928)
+++ /code/trunk/src/modules/overlays/hud/UnderAttackHealthBar.h	(revision 5929)
@@ -62,5 +62,5 @@
             PlayerInfo* owner_;
             OverlayText* text_;
-            Timer<UnderAttackHealthBar> inittimer_;
+            Timer inittimer_;
     };
 }
Index: /code/trunk/src/modules/overlays/stats/CreateLines.cc
===================================================================
--- /code/trunk/src/modules/overlays/stats/CreateLines.cc	(revision 5928)
+++ /code/trunk/src/modules/overlays/stats/CreateLines.cc	(revision 5929)
@@ -59,8 +59,8 @@
     CreateLines::~CreateLines()
     {
-        delete this->playerNameText_;
-        delete this->scoreText_;
-        delete this->deathsText_;
-        delete this->background_;
+        this->playerNameText_->destroy();
+        this->scoreText_->destroy();
+        this->deathsText_->destroy();
+        this->background_->destroy();
     }
 
Index: /code/trunk/src/modules/overlays/stats/Scoreboard.cc
===================================================================
--- /code/trunk/src/modules/overlays/stats/Scoreboard.cc	(revision 5928)
+++ /code/trunk/src/modules/overlays/stats/Scoreboard.cc	(revision 5929)
@@ -44,4 +44,14 @@
     {
         RegisterObject(Scoreboard);
+    }
+
+    Scoreboard::~Scoreboard()
+    {
+        while (this->lines_.size() > 0)
+        {
+            // destroy lines
+            delete this->lines_.back();
+            this->lines_.pop_back();
+        }
     }
 
Index: /code/trunk/src/modules/overlays/stats/Scoreboard.h
===================================================================
--- /code/trunk/src/modules/overlays/stats/Scoreboard.h	(revision 5928)
+++ /code/trunk/src/modules/overlays/stats/Scoreboard.h	(revision 5929)
@@ -42,5 +42,5 @@
     public: // functions
         Scoreboard(BaseObject* creator);
-        virtual ~Scoreboard() {}
+        virtual ~Scoreboard();
 
         virtual void XMLPort(Element& xmlElement, XMLPort::Mode mode);
Index: /code/trunk/src/modules/pong/CMakeLists.txt
===================================================================
--- /code/trunk/src/modules/pong/CMakeLists.txt	(revision 5928)
+++ /code/trunk/src/modules/pong/CMakeLists.txt	(revision 5929)
@@ -1,3 +1,4 @@
 SET_SOURCE_FILES(PONG_SRC_FILES
+COMPILATION_BEGIN PongCompilation.cc
   Pong.cc
   PongAI.cc
@@ -7,4 +8,5 @@
   PongCenterpoint.cc
   PongScore.cc
+COMPILATION_END
 )
 
@@ -12,7 +14,4 @@
   MODULE
   FIND_HEADER_FILES
-  PCH_FILE
-    PongPrecompiledHeaders.h
-  PCH_NO_DEFAULT
   DEFINE_SYMBOL
     "PONG_SHARED_BUILD"
Index: /code/trunk/src/modules/pong/Pong.cc
===================================================================
--- /code/trunk/src/modules/pong/Pong.cc	(revision 5928)
+++ /code/trunk/src/modules/pong/Pong.cc	(revision 5929)
@@ -30,4 +30,5 @@
 
 #include "core/CoreIncludes.h"
+#include "core/EventIncludes.h"
 #include "core/Executor.h"
 #include "PongCenterpoint.h"
@@ -39,4 +40,7 @@
 namespace orxonox
 {
+    CreateEventName(PongCenterpoint, right);
+    CreateEventName(PongCenterpoint, left);
+    
     CreateUnloadableFactory(Pong);
 
@@ -52,5 +56,5 @@
         this->setHUDTemplate("PongHUD");
 
-        this->starttimer_.setTimer(1.0, false, this, createExecutor(createFunctor(&Pong::startBall)));
+        this->starttimer_.setTimer(1.0, false, createExecutor(createFunctor(&Pong::startBall, this)));
         this->starttimer_.stopTimer();
 
@@ -72,4 +76,5 @@
             this->ball_->setFieldDimension(this->center_->getFieldDimension());
             this->ball_->setSpeed(0);
+            this->ball_->setAccelerationFactor(this->center_->getBallAccelerationFactor());
             this->ball_->setBatLength(this->center_->getBatLength());
 
@@ -120,5 +125,5 @@
         if (this->ball_)
         {
-            delete this->ball_;
+            this->ball_->destroy();
             this->ball_ = 0;
         }
@@ -155,8 +160,11 @@
         if (this->center_)
         {
-            this->center_->fireEvent();
-
+            if (player == this->getRightPlayer())
+                this->center_->fireEvent(FireEventName(PongCenterpoint, right));
+            else if (player == this->getLeftPlayer())
+                this->center_->fireEvent(FireEventName(PongCenterpoint, left));
+            
             if (player)
-                this->gtinfo_.sendAnnounceMessage(player->getName() + " scored");
+                this->gtinfo_->sendAnnounceMessage(player->getName() + " scored");
         }
 
@@ -165,4 +173,5 @@
             this->ball_->setPosition(Vector3::ZERO);
             this->ball_->setVelocity(Vector3::ZERO);
+            this->ball_->setAcceleration(Vector3::ZERO);
             this->ball_->setSpeed(0);
         }
Index: /code/trunk/src/modules/pong/Pong.h
===================================================================
--- /code/trunk/src/modules/pong/Pong.h	(revision 5928)
+++ /code/trunk/src/modules/pong/Pong.h	(revision 5929)
@@ -62,5 +62,5 @@
             PongBall* ball_;
             PongBat* bat_[2];
-            Timer<Pong> starttimer_;
+            Timer starttimer_;
     };
 }
